!type = 1 'impulse is selected in the radio options
!check = 0 'controls impulse checkbox

%prefix = "d_" 'prefix of the dummy name(s)

@uidialog("Caption", "Generate Dummies", "Radio", !type, "Type", "Impulse Stability")




'******************************IMPULSE SUBROUTINE**************************************
subroutine impulse_1

local smpl 

'error message if no prefix is used
if %prefix = "" then 
   @uiprompt("Enter dummy name prefix")
	stop
endif


'error message if no dates are entered 
if @length(%dates)=0 then
   @uiprompt("No date(s) have been entered")
	stop
endif

'error message if selected date(s) are outside workfile range
for %i {%dates} 
	if @dateval(%i)>@dateval(@otod(@obsrange)) or @dateval(%i)<@dateval(@otod(1)) then
  	   @uiprompt("Error in Sample: Attempt to set sample outside of workfile range")
		stop
	endif
next

'generate dummy variables
for %obs {%dates} 'loop for all dates entered


	'DAILY DATA
	if @pagefreq = "D5" or @pagefreq = "D7" then
	  	for %j {%dates} 
			
			'stop if date is incorrect
			if @dateval(%j) = na then
	   		   @uiprompt("Workfile Frequency: Daily. Please enter date(s) in different format, i.e. 01/01/1990")
				stop
			endif

			'the fifth character should not indicate monthly or quarterly data
			if (@mid(%j, 5, 1) = ":") or (@mid(%j, 5, 1) = "m") or (@mid(%j, 5, 1) = "M") or (@mid(%j, 5, 1) = "q") or (@mid(%j, 5, 1) = "Q") then 
		   	  @uiprompt("Workfile Frequency: Daily. Please enter date(s) in different format, i.e. 01/01/1990")
			stop
			endif

		'The number of characters for the enetered dates should be greater than 7 and less than 11
			if @length(%j)<8 or @length(%j)>10 then
		   	   @uiprompt("Workfile Frequency: Daily. Please enter date(s) in different format, i.e. 01/01/1990")
				stop
			endif
		next

		'name of dummy
		if @mid(%obs,2,1) = "/" or @mid(%obs,3,1) = "/" then
	  	%obs_1 = @wreplace(%obs, "*/*", "*_*") 'replaces the first "/" with "_"
	  	%obs_2 = @wreplace(%obs_1, "*/*", "*_*") 'replaces the second "/" with "_"
		%name = %prefix + %obs_2 'concatenate d_ and another string
		endif
	endif



	'WEEKLY DATA
	if @pagefreq = "W" then
	  	for %j {%dates} 

			'stop if date is incorrect
			if @dateval(%j) = na then
	   		   @uiprompt("Workfile Frequency: Weekly. Please enter date(s) in different format, i.e. 01/01/1990")
				stop
			endif

			'the fifth character should not indicate monthly or quarterly data
			if (@mid(%j, 5, 1) = ":") or (@mid(%j, 5, 1) = "m") or (@mid(%j, 5, 1) = "M") or (@mid(%j, 5, 1) = "q") or (@mid(%j, 5, 1) = "Q") then 
		   	  @uiprompt("Workfile Frequency: Weekly. Please enter date(s) in different format, i.e. 01/01/1990")
			stop
			endif

			'The number of characters for the enetered dates should be greater than 7 and less than 11
			if @length(%j)<8 or @length(%j)>10 then
		   	   @uiprompt("Workfile Frequency: Weekly. Please enter date(s) in different format, i.e. 01/01/1990")
				stop
			endif
		next

		'name of dummy
		if @mid(%obs,2,1) = "/" or @mid(%obs,3,1) = "/" then
	  	%obs_1 = @wreplace(%obs, "*/*", "*_*") 'replaces the first "/" with "_"
	  	%obs_2 = @wreplace(%obs_1, "*/*", "*_*") 'replaces the second "/" with "_"
		%name = %prefix + %obs_2 'concatenate d_ and another string
		endif
	endif



	'MONTHLY DATA
	if @pagefreq = "M" then
	  	for %j {%dates} 

			'stop if date is incorrect
			if @dateval(%j) = na then
	   		   @uiprompt("Workfile Frequency: Monthly. Please enter date(s) in different format, i.e. 1990M1")
				stop
			endif

			'the fifth character of the date should be eirther "m" or "M" or ":"
			if (@mid(%j, 5, 1) = "m") or (@mid(%j, 5, 1) = "M") or (@mid(%j, 5, 1) = ":") then
			else
  			  @uiprompt("Workfile Frequency: Monthly. Please enter date(s) in different format, i.e. 1990M1")
				stop
			endif

			'length of the date should be 7 or 8
			if @length(%j)<6 or  @length(%j)>8 then 
			   @uiprompt("Workfile Frequency: Monthly. Please enter date(s) in different format, i.e. 1990M1")
				stop
			endif

			'Month should be equal or less than 12
			%m = @mid(%j,6,10)
			if {%m}>12 then  
	 	  	   @uiprompt("Workfile Frequency: Monthly. Please enter date(s) in different format, i.e. 1990M1")
				stop
			endif
		next

		'name of the dummy
		if (@mid(%obs, 5, 1) = ":") then 
			  %name = %prefix + @left(%obs, 4) + "m" + @mid(%obs, 6)
			else
			  %name =%prefix + %obs
		endif		
	endif



	'QUARTERLY DATA
	if @pagefreq = "Q" then
		for %j {%dates} 

			'stop if date is incorrect
			if @dateval(%j) = na then
	   		   @uiprompt("Workfile Frequency: Quarterly. Please enter date(s) in different format, i.e. 1990Q1")
				stop
			endif

			'the fifth character of the date should be eirther "q" or ":"
			if (@mid(%j, 5, 1) = "q") or  (@mid(%j, 5, 1) = "Q") or (@mid(%j, 5, 1) = ":") then
			else
  			   @uiprompt("Workfile Frequency: Quarterly. Please enter date(s) in different format, i.e. 1990Q1")
				stop
			endif

			'length of the date should be 6
			if @length(%j)<>6 then 
			   @uiprompt("Workfile Frequency: Quarterly. Please enter date(s) in different format, i.e. 1990Q1")
				stop
			endif

			'Quarters should be less or equal to 4
			%q = @mid(%j,6,10)
			if {%q}>4 then  
	 	         @uiprompt("Workfile Frequency: Quarterly. Please enter date(s) in different format, i.e. 1990Q1")
				stop
			endif
		next


		'name of the dummy
		if (@mid(%obs, 5, 1) = ":") then 
		    %name = %prefix + @left(%obs, 4) + "q" + @mid(%obs, 6)
		else
		    %name = %prefix + %obs
		endif		
	endif



	'ANNUAL DATA
	if @pagefreq = "A" then
			for %j {%dates} 
			if @val(%j) = na or @val(%j) < 0 then
		     	   @uiprompt("Workfile Frequency: Annual. Please enter date(s) in different format, i.e. 1990")
				stop
			endif

			'length of the date should be 4
			if @length(%j)<>4 then 
		  	   @uiprompt("Workfile Frequency: Annual. Please enter date(s) in different format, i.e. 1990")
				stop
			endif
		next	
	
	'name of the dummy
	%name = %prefix + %obs	
	endif



	'UNDATED DATA
	if @pagefreq = "U" then
	   for %j {%dates} 
			if @val(%j) = na or  @val(%j) < 0 then
		   	   @uiprompt("Workfile Frequency: Undated. Please enter date(s) in different format, i.e. 1990")
				stop
			endif
	   next
	   'name of the dummy
	    %name = %prefix + %obs
	endif

	
	
	'generate dummy series
   	smpl @all
   	series {%name} = 0 'creates a series equal to zero
   	smpl {%obs} {%obs} 'sets the sample to %obsstr %obsstr (1 observation)
   	series {%name} = 1 'replaces the value of the series for the above sample (1 obs) with one.
	
next

endsub




'********************************IMPULSE ALL SUBROUTINE**************************************
subroutine impulse_all

local smpl 

'error message if no prefix is used
if %prefix = "" then 
    @uiprompt("Enter dummy name prefix")
	stop
endif


'generate dummy variables for all observations in the workfile
for !i = 1 to @obsrange

	'string containing observation offset
	%obs = @otod(!i) 'returns a string representation of the date associated with a single observation 

	'name of dummy - WEEKLY AND DAILY DATA
	if @mid(%obs,2,1) = "/" or @mid(%obs,3,1) = "/" then
	   %obs_1 = @wreplace(%obs, "*/*", "*_*") 
	   %obs_2 = @wreplace(%obs_1, "*/*", "*_*")
	   %name = %prefix + %obs_2
	endif

	'name of dummy - MONTHLY DATA
	if @pagefreq = "M" then
		if (@mid(%obs, 5, 1) = ":") then
 		   %name = %prefix + @left(%obs, 4) + "m" + @mid(%obs, 6)
		else
		   %name = %prefix + %obs
		endif
	endif

	'name of dummy - QUARTERLY DATA
	if @pagefreq = "Q" then
		if (@mid(%obs, 5, 1) = ":") then
 		   %name = %prefix + @left(%obs, 4) + "q" + @mid(%obs, 6)
		else
		   %name = %prefix + %obs
		endif
	endif

	'name of dummy - ANNUAL AND UNDATED DATA
	if @pagefreq = "A" or @pagefreq = "U" then
	   %name = %prefix + %obs
	endif

 
'generate dummy series
   smpl @all
   series {%name} = 0 'creates a series equal to zero
   smpl {%obs} {%obs} 'sets the sample to %obsstr %obsstr (1 observation)
   series {%name} = 1 'replaces the value of the series for the above sample / observation with one.

next

endsub





'***********************************STABILITY SUBROUTINE**********************************
subroutine stability

local smpl 

'error message if no prefix is used
if %prefix = "" then 
 @uiprompt("Enter dummy name prefix")
	stop
endif

'if no dates are entered, then show an error message
if @length(%start)=0 then
   @uiprompt("Enter a Start date")
	stop
endif

if @length(%end)=0 then
   @uiprompt("Enter an End date")
	stop
endif

'error message if selected date(s) are outside workfile range
if @dateval(%end)>@dateval(@otod(@obsrange)) or @dateval(%start)<@dateval(@otod(1)) then
   @uiprompt("Error in Sample: Attempt to set sample outside of workfile range")
	stop
endif

'error message if starting date is before the end sample
if @dateval(%end) < @dateval(%start) then
   @uiprompt("Error in Sample: Start date greater than the End date")
	stop
endif


'DAILY DATA
if @pagefreq = "D5" or @pagefreq = "D7" then
	  	
	'the fifth character should not indicate monthly or quarterly data
	if (@mid(%start, 5, 1) = ":") or (@mid(%start, 5, 1) = "m") or (@mid(%start, 5, 1) = "M") or (@mid(%start, 5, 1) = "q") or (@mid(%start, 5, 1) = "Q") or (@mid(%end, 5, 1) = ":") or (@mid(%end, 5, 1) = "m") or (@mid(%end, 5, 1) = "M") or (@mid(%end, 5, 1) = "q") or (@mid(%end, 5, 1) = "Q") then 
	  @uiprompt("Workfile Frequency: Daily. Please enter date(s) in different format, i.e. 01/01/1990")
		stop
	endif

	'stop if dates are incorrect
	if @dateval(%start) = na or @dateval(%end) = na then
	   @uiprompt("Workfile Frequency: Daily. Please enter date(s) in different format, i.e. 01/01/1990")
		stop
	endif

	'The number of characters for the enetered dates should be greater than 7 and less than 11
	if @length(%start)<8 or @length(%start)>10 or @length(%end)<8 or @length(%end)>10 then
	   @uiprompt("Workfile Frequency: Daily. Please enter date(s) in different format, i.e. 01/01/1990")
		stop
	endif
		

	'name of dummy
	if @mid(%start,2,1) = "/" or @mid(%start,3,1) = "/" then
	  %start_1 = @wreplace(%start, "*/*", "*_*") 'replaces the first "/" with "_"
	  %start_2 = @wreplace(%start_1, "*/*", "*_*") 'replaces the second "/" with "_"
	  %name = %prefix + %start_2 'concatenate d_ and another string
	endif
endif




'WEEKLY DATA
if @pagefreq = "W" then
	  	
	'the fifth character should not indicate monthly or quarterly data
	if (@mid(%start, 5, 1) = ":") or (@mid(%start, 5, 1) = "m") or (@mid(%start, 5, 1) = "M") or (@mid(%start, 5, 1) = "q") or (@mid(%start, 5, 1) = "Q") or (@mid(%end, 5, 1) = ":") or (@mid(%end, 5, 1) = "m") or (@mid(%end, 5, 1) = "M") or (@mid(%end, 5, 1) = "q") or (@mid(%end, 5, 1) = "Q") then 
	  @uiprompt("Workfile Frequency: Weekly. Please enter date(s) in different format, i.e. 01/01/1990")
		stop
	endif

	'stop if dates are incorrect
	if @dateval(%start) = na or @dateval(%end) = na then
	   @uiprompt("Workfile Frequency: Weekly. Please enter date(s) in different format, i.e. 01/01/1990")
		stop
	endif

	'The number of characters for the enetered dates should be greater than 7 and less than 11
	if @length(%start)<8 or @length(%start)>10 or @length(%end)<8 or @length(%end)>10 then
	   @uiprompt("Workfile Frequency: Weekly. Please enter date(s) in different format, i.e. 01/01/1990")
		stop
	endif
		

	'name of dummy
	if @mid(%start,2,1) = "/" or @mid(%start,3,1) = "/" then
	  %start_1 = @wreplace(%start, "*/*", "*_*") 'replaces the first "/" with "_"
	  %start_2 = @wreplace(%start_1, "*/*", "*_*") 'replaces the second "/" with "_"
	  %name = %prefix + %start_2 'concatenate d_ and another string
	endif
endif



'MONTHLY DATA
if @pagefreq = "M" then
		 
	'the fifth character of the date should be eirther "m" or ":"
	if (@mid(%start, 5, 1) = "m") or (@mid(%start, 5, 1) = "M") or (@mid(%start, 5, 1) = ":") then 
	else
  	   @uiprompt("Workfile Frequency: Monthly. Please enter date(s) in different format, i.e. 1990M1")
		stop
	endif

	'the fifth character of the date should be eirther "m" or ":"
	if (@mid(%end, 5, 1) = "m") or (@mid(%end, 5, 1) = "M") or (@mid(%end, 5, 1) = ":") then 
	else
  	   @uiprompt("Workfile Frequency: Monthly. Please enter date(s) in different format, i.e. 1990M1")
		stop
	endif

	'stop if dates are incorrect
	if @dateval(%start) = na or @dateval(%end) = na then
	   @uiprompt("Workfile Frequency: Monthly. Please enter date(s) in different format, i.e.1990M1")
		stop
	endif

	'length of the date should be 6
	if @length(%start)<6 or @length(%end)<6 or @length(%start)>7 and @length(%end)>7 then 
	   @uiprompt("Workfile Frequency: Monthly. Please enter date(s) in different format, i.e. 1990M1")
		stop
	endif

	'Months should be less or equal to 12
	%m_s = @mid(%start,6,10)
	if {%m_s}>12 then  
	   @uiprompt("Workfile Frequency: Monthly. Please enter date(s) in different format, i.e. 1990M1")
		stop
	endif

	%m_e = @mid(%end,6,10)
	if {%m_e}>12 then  
	   @uiprompt("Workfile Frequency: Monthly. Please enter date(s) in different format, i.e. 1990M1")
		stop
	endif
	
	'name of the dummy
	if (@mid(%start, 5, 1) = ":") then 
	   %name = %prefix + @left(%start, 4) + "m" + @mid(%start, 6)
	else
	   %name = %prefix + %start
	endif		
endif



'QUARTERLY DATA
if @pagefreq = "Q" then

		 
	'the fifth character of the date should be eirther "q" or ":"
	if (@mid(%start, 5, 1) = "q") or (@mid(%start, 5, 1) = "Q") or (@mid(%start, 5, 1) = ":") then 
	else
  	  @uiprompt("Workfile Frequency: Quarterly. Please enter date(s) in different format, i.e. 1990Q1")
		stop
	endif

	'the fifth character of the date should be eirther "q" or ":"
	if (@mid(%end, 5, 1) = "q") or (@mid(%end, 5, 1) = "Q") or (@mid(%end, 5, 1) = ":") then 
	else
  	    @uiprompt("Workfile Frequency: Quarterly. Please enter date(s) in different format, i.e. 1990Q1")
		stop
	endif

	'stop if dates are incorrect
	if @dateval(%start) = na or @dateval(%end) = na then
	   @uiprompt("Workfile Frequency: Quarterly. Please enter date(s) in different format, i.e.1990Q1")
		stop
	endif

	'length of the date should be 6
	if @length(%start)<>6 or @length(%end)<>6 then 
	   @uiprompt("Workfile Frequency: Quarterly. Please enter date(s) in different format, i.e. 1990Q1")
		stop
	endif

	'Quarters should be less or equal to 4
	%q_s = @mid(%start,6,10)
	if {%q_s}>4 then  
	   @uiprompt("Workfile Frequency: Quarterly. Please enter date(s) in different format, i.e. 1990Q1")
		stop
	endif

	%q_e = @mid(%end,6,10)
	if {%q_e}>4 then  
	   @uiprompt("Workfile Frequency: Quarterly. Please enter date(s) in different format, i.e. 1990Q1")
		stop
	endif
	
	'name of the dummy
	if (@mid(%start, 5, 1) = ":") then 
	   %name = %prefix + @left(%start, 4) + "q" + @mid(%start, 6)
	else
	   %name = %prefix + %start
	endif		
endif



'ANNUAL DATA
if @pagefreq = "A" then

	'stop if dates are incorrect
	if @val(%start) = na or @val(%end) = na  or @val(%start)  < 0 or @val(%end)  < 0 then
	   @uiprompt("Workfile Frequency: Annual. Please enter date(s) in different format, i.e. 1990")
		stop
	endif

			 
	'length of the date should be 6
	if @length(%start)<>4 or @length(%end)<>4 then 
	   @uiprompt("Workfile Frequency: Annual. Please enter date(s) in different format, i.e. 1990")
		stop
	endif
	
	'name of the dummy
   	%name = %prefix + %start
			
endif



'UNDATED DATA
if @pagefreq = "U" then
	
	'stop if dates are incorrect
	if @val(%start) = na or @val(%end) = na or  @val(%start) < 0 or @val(%end) < 0  then
	   @uiprompt("Workfile Frequency: Undated. Please enter date(s) in different format, i.e. 1990")
		stop
	endif

	'name of the dummy
   	%name = %prefix + %start
endif

 
'generate dummy series
   smpl @all
   series {%name} = 0 'creates a series equal to zero
   smpl {%start} {%end} 'sets the sample to %obsstr %obsstr (1 observation)
   series {%name} = 1 'replaces the value of the series for the above sample / observation with one.


endsub





'*****************************************DIALOG CONTROL*************************************
'Dialog if Impulse is selected
if !type = 1 then
	@uidialog("Caption", "Generate Impulse Dummies",  "Edit",%dates, "Date(s)", "Text", "Example: 1/1/1990, 1990M1, 1990:1", "Check",!check, "All", "Text", " ", "Edit",%prefix, "Dummy Name Prefix")

	'generate impulse dummies for selected observations
	if !check = 0 then 
	   call impulse_1

	'generate dummies for all possible observations
	else
	   call impulse_all 
	endif
endif


'Dialog if Stability is selected
if !type = 2 then
   @uidialog("Caption", "Enter Period When Dummy = 1", "Edit",%start,"Start Date", "Edit",%end, "End Date", "Text", " ", "Edit", %prefix, "Dummy Name Prefix")
   call stability
endif


'smpl @all
'show {%prefix}*
